org.apache.felix.cm.json.io

## Interface ConfigurationReader

    @ProviderType
    public interface ConfigurationReader

A configuration reader can read configuration resources as defined in OSGi Configurator specificiation. A reader can be obtained through a `ConfigurationReader.Builder`.

### Nested Class Summary

Nested Classes
`static interface` `ConfigurationReader.BinaryHandler` Handler for binary properties
`static interface` `ConfigurationReader.Builder` Builder to create a reader.
`static interface` `ConfigurationReader.ConfiguratorPropertyHandler` Handler for configurator properties

### Method Summary

All Methods Instance Methods Abstract Methods
`List<String>` `getIgnoredErrors()` After reading a configuration (resource) this method will return a list of ignored errors.
`Hashtable<String,Object>` `readConfiguration()` Read a single configuration from the provided reader.
`ConfigurationResource` `readConfigurationResource()` Read a configuration resource from the provided reader.

### Method Detail

#### readConfiguration

    Hashtable<String,Object> readConfiguration()
                                        throws IOException

Read a single configuration from the provided reader. The reader is not closed. `getIgnoredErrors()` can be used after reading if any ignored errors occurred during processing the configuration.

Returns:
  The read configuration.
Throws:
  `IOException` - If reading fails

#### readConfigurationResource

    ConfigurationResource readConfigurationResource()
                                             throws IOException

Read a configuration resource from the provided reader. The reader is not closed. `getIgnoredErrors()` can be used after reading if any ignored errors occurred during processing the resource.

Returns:
  The read configurations.
Throws:
  `IOException` - If reading fails

#### getIgnoredErrors

    List<String> getIgnoredErrors()

After reading a configuration (resource) this method will return a list of ignored errors.

Returns:
  List of ignored errors, might be empty.